package com.intersult.jsf2;

import java.io.IOException;

import javax.faces.component.UIComponent;
import javax.faces.view.facelets.FaceletContext;
import javax.faces.view.facelets.TagAttribute;
import javax.faces.view.facelets.TagConfig;
import javax.faces.view.facelets.TagHandler;

public class DelegateHandler extends TagHandler {
	public DelegateHandler(TagConfig config) {
		super(config);
	}

	@Override
	public void apply(FaceletContext ctx, UIComponent component) throws IOException {
		UIComponent parent = component.getParent();
		parent.getChildren().add(new Delegate(parent));
		nextHandler.apply(ctx, component);
		parent.getFacets().putAll(component.getFacets());
		component.getFacets().clear();
		for (TagAttribute attribute : tag.getAttributes().getAll()) {
			if (attribute.isLiteral()) {
				parent.getAttributes().put(attribute.getLocalName(), attribute.getValue());
			} else {
				ctx.getVariableMapper().setVariable(
					attribute.getLocalName(), attribute.getValueExpression(ctx, Object.class));
			}
		}
	}
}